// thread2.cpp
// Glenn G. Chappell
// 4 Feb 2013
//
// For CS 321 Spring 2013
// Vector of thread objects, exception handling

#include <iostream>
using std::cout;
using std::endl;
#include <thread>
using std::thread;
#include <vector>
using std::vector;
#include <cstdlib>
using std::exit;


// Run function for spawned threads
void run(int n)
{
    // Give the scheduler something to play with
    int j = 0;
    for (int i = 0; i < 1000000; ++i)
        ++j;

    // Now print our number and terminate
    cout << "Slave: This is thread #" << n << endl;
}


int main()
{
    const int NUMTHREADS = 20;
    cout << "Master: Spawning " << NUMTHREADS
         << " threads, joining all of them"
         << endl;

    // Vector of thread objects, not yet holding actual threads
    vector<thread> ts(NUMTHREADS);

    // Spawn all threads
    for (int i = 0; i < NUMTHREADS; ++i)
    {
        try
        {
            ts[i] = thread(run, i);
        }
        catch(...)
        {
            cout << endl;
            cout << "ERROR: It appears that we can only spawn "
                 << i << " threads on this system." << endl;
            cout << "  Try reducing NUMTHREADS to " << i
                 << " and recompiling." << endl;
            exit(1);
        }
    }

    // Join all spawned threads
    for (int i = 0; i < NUMTHREADS; ++i)
    {
        ts[i].join();
    }

    return 0;
}

